const rl = @import("raylib");
const std = @import("std");
const EnS = @import("EntitySystem.zig");
const Etyp = @import("EntitySystemTypes.zig");

pub fn main() anyerror!void {
    const screenWidth = 1280;
    const screenHeight = 720;

    rl.initWindow(screenWidth, screenHeight, "AHHHH");
    defer rl.closeWindow();
    var alloc = std.heap.ArenaAllocator.init(std.heap.page_allocator);
    var ptr = try alloc.allocator().create(Etyp.Transform);
    ptr.* = Etyp.Transform{.pos = rl.Vector2.init(0, 0), .rot = 0};

    //rl.setTargetFPS(60);
    try EnS.Init();
    try EnS.RegisterComponent(Etyp.Transform);



    var player = try EnS.CreateEntity();
    
    EnS.AddComponent(player, Etyp.Transform{.pos = rl.Vector2.init(0, 0), .rot = 0});


    while (!rl.windowShouldClose()) {
        Etyp.Systems.Gravity();



        rl.beginDrawing();
        defer rl.endDrawing();
        var pos = EnS.GetComponent(player, Etyp.Transform).pos;

        rl.drawRectangle(pos.x, pos.y, 5, 5, rl.Color.gold);
    
        rl.clearBackground(rl.Color.black);
        rl.drawFPS(10, 10);
    }
}

